Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1047)
+++ palm/trunk/SOURCE/Makefile	(revision 1053)
@@ -20,5 +20,5 @@
 # Current revisions:
 # ------------------
-# 
+# +microphysics for two-moment cloud physics
 #
 # Former revisions:
@@ -159,5 +159,6 @@
 	user_parin.f90 user_read_restart_data.f90 \
 	user_spectra.f90 user_statistics.f90 wall_fluxes.f90 \
-	write_3d_binary.f90 write_compressed.f90 write_var_list.f90
+	write_3d_binary.f90 write_compressed.f90 write_var_list.f90 \
+	microphysics.f90
 
 OBJS =  advec_s_bc.o advec_s_pw.o advec_s_up.o advec_u_pw.o advec_u_up.o \
@@ -205,5 +206,6 @@
 	user_lpm_init.o user_lpm_set_attributes.o user_module.o user_parin.o \
 	user_read_restart_data.o user_spectra.o user_statistics.o \
-	wall_fluxes.o write_3d_binary.o write_compressed.o write_var_list.o
+	wall_fluxes.o write_3d_binary.o write_compressed.o write_var_list.o \
+	microphysics.o
 
 CC = cc
@@ -346,5 +348,6 @@
 	eqn_state_seawater.o impact_of_latent_heat.o \
         plant_canopy_model.o production_e.o \
-	subsidence.o user_actions.o
+	subsidence.o user_actions.o \
+	microphysics.o
 random_gauss.o: random_function.o
 read_3d_binary.o: modules.o random_function.o
@@ -394,2 +397,3 @@
 write_compressed.o: modules.o
 write_var_list.o: modules.o
+microphysics.o: modules.o
Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 1047)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 1053)
@@ -20,4 +20,7 @@
 ! Current revisions:
 ! ------------------
+! necessary expansions according to the two new prognostic equations (nr, qr) 
+! of the two-moment cloud physics scheme:
+! +flux_l_*, flux_s_*, diss_l_*, diss_s_*, sums_ws*s_ws_l 
 !
 ! Former revisions:
@@ -210,4 +213,11 @@
           ENDIF
 
+          IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+             ALLOCATE( sums_wsqrs_ws_l(nzb:nzt+1,0:threads_per_task-1) )
+             ALLOCATE( sums_wsnrs_ws_l(nzb:nzt+1,0:threads_per_task-1) )
+             sums_wsqrs_ws_l = 0.0
+             sums_wsnrs_ws_l = 0.0
+          ENDIF
+
           IF ( ocean )  THEN
              ALLOCATE( sums_wssas_ws_l(nzb:nzt+1,0:threads_per_task-1) )
@@ -253,9 +263,20 @@
 
              IF ( humidity .OR. passive_scalar )  THEN
-                ALLOCATE( flux_s_q(nzb+1:nzt,0:threads_per_task-1),         &
+                ALLOCATE( flux_s_q(nzb+1:nzt,0:threads_per_task-1),          &
                           diss_s_q(nzb+1:nzt,0:threads_per_task-1) )
-                ALLOCATE( flux_l_q(nzb+1:nzt,nys:nyn,0:threads_per_task-1), &
+                ALLOCATE( flux_l_q(nzb+1:nzt,nys:nyn,0:threads_per_task-1),  &
                           diss_l_q(nzb+1:nzt,nys:nyn,0:threads_per_task-1) )
              ENDIF
+
+             IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+                ALLOCATE( flux_s_qr(nzb+1:nzt,0:threads_per_task-1),         &
+                          diss_s_qr(nzb+1:nzt,0:threads_per_task-1),         &
+                          flux_s_nr(nzb+1:nzt,0:threads_per_task-1),         &
+                          diss_s_nr(nzb+1:nzt,0:threads_per_task-1) )
+                ALLOCATE( flux_l_qr(nzb+1:nzt,nys:nyn,0:threads_per_task-1), &
+                          diss_l_qr(nzb+1:nzt,nys:nyn,0:threads_per_task-1), &
+                          flux_l_nr(nzb+1:nzt,nys:nyn,0:threads_per_task-1), &
+                          diss_l_nr(nzb+1:nzt,nys:nyn,0:threads_per_task-1) ) 
+             END IF
 
              IF ( ocean )  THEN
@@ -297,4 +318,8 @@
           sums_wspts_ws_l = 0.0
           IF ( humidity .OR. passive_scalar )  sums_wsqs_ws_l = 0.0
+          IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+             sums_wsqrs_ws_l = 0.0
+             sums_wsnrs_ws_l = 0.0
+          ENDIF
           IF ( ocean )  sums_wssas_ws_l = 0.0
 
@@ -307,6 +332,6 @@
 ! Scalar advection - Call for grid point i,j
 !------------------------------------------------------------------------------!
-    SUBROUTINE advec_s_ws_ij( i, j, sk, sk_char,swap_flux_y_local,  &
-                              swap_diss_y_local, swap_flux_x_local, &
+    SUBROUTINE advec_s_ws_ij( i, j, sk, sk_char, swap_flux_y_local,  &
+                              swap_diss_y_local, swap_flux_x_local,  &
                               swap_diss_x_local, i_omp, tn )
 
@@ -727,4 +752,21 @@
                                  * weight_substep(intermediate_timestep_count)
              ENDDO
+
+          CASE ( 'qr' )
+
+             DO  k = nzb, nzt
+                sums_wsqrs_ws_l(k,tn)  = sums_wsqrs_ws_l(k,tn) +               &
+                                      ( flux_t(k) + diss_t(k) )                &
+                                 * weight_substep(intermediate_timestep_count)
+             ENDDO
+
+          CASE ( 'nr' )
+
+             DO  k = nzb, nzt
+                sums_wsnrs_ws_l(k,tn)  = sums_wsnrs_ws_l(k,tn) +               &
+                                      ( flux_t(k) + diss_t(k) )                &
+                                 * weight_substep(intermediate_timestep_count)
+             ENDDO
+
 
          END SELECT
Index: palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/average_3d_data.f90	(revision 1047)
+++ palm/trunk/SOURCE/average_3d_data.f90	(revision 1053)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! averaging of nr, qr added
 !
 ! Former revisions:
@@ -117,4 +117,13 @@
              ENDDO
 
+          CASE ( 'nr' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      nr_av(k,j,i) = nr_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
+
           CASE ( 'p' )
              DO  i = nxlg, nxrg
@@ -207,4 +216,13 @@
              ENDDO
 
+          CASE ( 'qr' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      qr_av(k,j,i) = qr_av(k,j,i) / REAL( average_count_3d )
+                   ENDDO
+                ENDDO
+             ENDDO
+
           CASE ( 'qv' )
              DO  i = nxlg, nxrg
Index: palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/boundary_conds.f90	(revision 1047)
+++ palm/trunk/SOURCE/boundary_conds.f90	(revision 1053)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-!
+! boundary conditions for the two new prognostic equations (nr, qr) of the 
+! two-moment cloud scheme
 !  
 ! Former revisions:
@@ -216,4 +217,43 @@
 !--       Top boundary
           q_p(nzt+1,:,:) = q_p(nzt,:,:)   + bc_q_t_val * dzu(nzt+1)
+
+          IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+!             
+!--          Surface conditions for constant_humidity_flux
+             IF ( ibc_qr_b == 0 ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      qr_p(nzb_s_inner(j,i),j,i) = qr(nzb_s_inner(j,i),j,i)
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      qr_p(nzb_s_inner(j,i),j,i) = qr_p(nzb_s_inner(j,i)+1,j,i)
+                   ENDDO
+                ENDDO
+             ENDIF
+!
+!--          Top boundary
+             qr_p(nzt+1,:,:) = qr_p(nzt,:,:) + bc_qr_t_val * dzu(nzt+1)
+!             
+!--          Surface conditions for constant_humidity_flux
+             IF ( ibc_nr_b == 0 ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      nr_p(nzb_s_inner(j,i),j,i) = nr(nzb_s_inner(j,i),j,i)
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      nr_p(nzb_s_inner(j,i),j,i) = nr_p(nzb_s_inner(j,i)+1,j,i)
+                   ENDDO
+                ENDDO
+             ENDIF
+!
+!--          Top boundary
+             nr_p(nzt+1,:,:) = nr_p(nzt,:,:) + bc_nr_t_val * dzu(nzt+1)
+          ENDIF
 
        ENDIF
@@ -242,17 +282,41 @@
           pt_p(:,nys-1,:)     = pt_p(:,nys,:)
           IF ( .NOT. constant_diffusion     )  e_p(:,nys-1,:) = e_p(:,nys,:)
-          IF ( humidity .OR. passive_scalar )  q_p(:,nys-1,:) = q_p(:,nys,:)
+          IF ( humidity .OR. passive_scalar )  THEN
+             q_p(:,nys-1,:) = q_p(:,nys,:)
+             IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+                qr_p(:,nys-1,:) = qr_p(:,nys,:)
+                nr_p(:,nys-1,:) = nr_p(:,nys,:)
+             ENDIF
+          ENDIF
        ELSEIF ( outflow_n )  THEN
           pt_p(:,nyn+1,:)     = pt_p(:,nyn,:)
           IF ( .NOT. constant_diffusion     )  e_p(:,nyn+1,:) = e_p(:,nyn,:)
-          IF ( humidity .OR. passive_scalar )  q_p(:,nyn+1,:) = q_p(:,nyn,:)
+          IF ( humidity .OR. passive_scalar )  THEN
+             q_p(:,nyn+1,:) = q_p(:,nyn,:)
+             IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+                qr_p(:,nyn+1,:) = qr_p(:,nyn,:)
+                nr_p(:,nyn+1,:) = nr_p(:,nyn,:)
+             ENDIF
+          ENDIF
        ELSEIF ( outflow_l )  THEN
           pt_p(:,:,nxl-1)     = pt_p(:,:,nxl)
           IF ( .NOT. constant_diffusion     )  e_p(:,:,nxl-1) = e_p(:,:,nxl)
-          IF ( humidity .OR. passive_scalar )  q_p(:,:,nxl-1) = q_p(:,:,nxl)
+          IF ( humidity .OR. passive_scalar )  THEN
+             q_p(:,:,nxl-1) = q_p(:,:,nxl)
+             IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+                qr_p(:,:,nxl-1) = qr_p(:,:,nxl)
+                nr_p(:,:,nxl-1) = nr_p(:,:,nxl)
+             ENDIF
+          ENDIF
        ELSEIF ( outflow_r )  THEN
           pt_p(:,:,nxr+1)     = pt_p(:,:,nxr)
           IF ( .NOT. constant_diffusion     )  e_p(:,:,nxr+1) = e_p(:,:,nxr)
-          IF ( humidity .OR. passive_scalar )  q_p(:,:,nxr+1) = q_p(:,:,nxr)
+          IF ( humidity .OR. passive_scalar )  THEN
+             q_p(:,:,nxr+1) = q_p(:,:,nxr)
+             IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+                qr_p(:,:,nxr+1) = qr_p(:,:,nxr)
+                nr_p(:,:,nxr+1) = nr_p(:,:,nxr)
+             ENDIF
+          ENDIF
        ENDIF
 
Index: palm/trunk/SOURCE/calc_liquid_water_content.f90
===================================================================
--- palm/trunk/SOURCE/calc_liquid_water_content.f90	(revision 1047)
+++ palm/trunk/SOURCE/calc_liquid_water_content.f90	(revision 1053)
@@ -20,4 +20,5 @@
 ! Current revisions:
 ! -----------------
+! description expanded to the two-moment cloud scheme
 !
 ! Former revisions:
@@ -51,5 +52,7 @@
 ! Description:
 ! ------------
-! Calculation of the liquid water content (0%-or-100%-scheme)
+! Calculation of the liquid water content (0%-or-100%-scheme). This scheme is 
+! used by the one and the two moment cloud physics scheme. Using the two moment 
+! scheme, this calculation results in the cloud water content.
 !------------------------------------------------------------------------------!
 
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 1047)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1053)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-!
+! necessary changes for the new two-moment cloud physics scheme added:
+! - check cloud physics scheme (Kessler or Seifert and Beheng)
+! - plant_canopy is not allowed
+! - currently, only cache loop_optimization is allowed 
+! - initial profiles of nr, qr
+! - boundary condition of nr, qr
+! - check output quantities (qr, nr, prr)
 !
 ! Former revisions:
@@ -617,5 +623,15 @@
 
     ENDIF
-
+!
+!-- Check cloud scheme
+    IF ( cloud_scheme == 'seifert_beheng' )  THEN
+       icloud_scheme = 0
+    ELSEIF ( cloud_scheme == 'kessler' )  THEN
+       icloud_scheme = 1
+    ELSE
+       message_string = 'unknown cloud microphysics scheme cloud_scheme ="' // &
+                        TRIM( cloud_scheme ) // '"'
+       CALL message( 'check_parameters', 'PA0357', 1, 2, 0, 6, 0 )
+    ENDIF
 !
 !-- Check whether there are any illegal values
@@ -853,4 +869,17 @@
     ENDIF 
 
+    IF ( plant_canopy  .AND.  cloud_physics  .AND.  icloud_scheme == 0 ) THEN
+       message_string = 'plant_canopy = .TRUE. requires cloud_scheme /=' //  &
+                        ' seifert_beheng'
+       CALL message( 'check_parameters', 'PA0360', 1, 2, 0, 6, 0 )
+    ENDIF 
+
+    IF ( loop_optimization /= 'cache' .AND.  cloud_physics  .AND.            &
+         icloud_scheme == 0 ) THEN
+       message_string = 'cloud_scheme = seifert_beheng requires ' // &
+                        'loop_optimization = cache'
+       CALL message( 'check_parameters', 'PA0362', 1, 2, 0, 6, 0 )
+    ENDIF 
+
 !
 !-- In case of no model continuation run, check initialising parameters and
@@ -861,5 +890,14 @@
 !--    Initial profiles for 1D and 3D model, respectively (u,v further below)
        pt_init = pt_surface
-       IF ( humidity )        q_init  = q_surface
+       IF ( humidity )  THEN
+          q_init  = q_surface
+!
+!--       It is not allowed to choose initial profiles of rain water content 
+!--       and rain drop concentration. They are set to 0.0.
+          IF ( cloud_physics .AND. icloud_scheme == 0 ) THEN
+             qr_init = 0.0
+             nr_init = 0.0
+          ENDIF
+       ENDIF
        IF ( ocean )           sa_init = sa_surface
        IF ( passive_scalar )  q_init  = s_surface
@@ -1167,8 +1205,84 @@
           ENDIF
 
-!
-!--       Store humidity gradient at the top boundary for possile Neumann
-!--       boundary condition
-          bc_q_t_val = ( q_init(nzt+1) - q_init(nzt) ) / dzu(nzt+1)
+          IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+
+             i = 1
+             gradient = 0.0
+             qr_vertical_gradient_level_ind(1) = 0
+             DO  k = 1, nzt+1
+                IF ( i < 11 ) THEN
+                   IF ( qr_vertical_gradient_level(i) < zu(k)  .AND. &
+                        qr_vertical_gradient_level(i) >= 0.0 )  THEN
+                      gradient = qr_vertical_gradient(i) / 100.0
+                      qr_vertical_gradient_level_ind(i) = k - 1
+                      i = i + 1
+                   ENDIF
+                ENDIF
+                IF ( gradient /= 0.0 )  THEN
+                   IF ( k /= 1 )  THEN
+                      qr_init(k) = qr_init(k-1) + dzu(k) * gradient
+                   ELSE
+                      qr_init(k) = qr_init(k-1) + 0.5 * dzu(k) * gradient
+                   ENDIF
+                ELSE
+                   qr_init(k) = qr_init(k-1)
+                ENDIF
+!
+!--             Avoid negative rain water content
+                IF ( qr_init(k) < 0.0 )  THEN
+                   qr_init(k) = 0.0
+                ENDIF
+             ENDDO
+!
+!--          In case of no given rain water content gradients, choose zero gradient
+!--          conditions
+             IF ( qr_vertical_gradient_level(1) == -1.0 )  THEN
+                qr_vertical_gradient_level(1) = 0.0
+             ENDIF
+
+             i = 1
+             gradient = 0.0
+             nr_vertical_gradient_level_ind(1) = 0
+             DO  k = 1, nzt+1
+                IF ( i < 11 ) THEN
+                   IF ( nr_vertical_gradient_level(i) < zu(k)  .AND. &
+                        nr_vertical_gradient_level(i) >= 0.0 )  THEN
+                      gradient = nr_vertical_gradient(i) / 100.0
+                      nr_vertical_gradient_level_ind(i) = k - 1
+                      i = i + 1
+                   ENDIF
+                ENDIF
+                IF ( gradient /= 0.0 )  THEN
+                   IF ( k /= 1 )  THEN
+                      nr_init(k) = nr_init(k-1) + dzu(k) * gradient
+                   ELSE
+                      nr_init(k) = nr_init(k-1) + 0.5 * dzu(k) * gradient
+                   ENDIF
+                ELSE
+                   nr_init(k) = nr_init(k-1)
+                ENDIF
+!
+!--             Avoid negative rain water content
+                IF ( nr_init(k) < 0.0 )  THEN
+                   nr_init(k) = 0.0
+                ENDIF
+             ENDDO
+!
+!--          In case of no given rain water content gradients, choose zero gradient
+!--          conditions
+             IF ( nr_vertical_gradient_level(1) == -1.0 )  THEN
+                nr_vertical_gradient_level(1) = 0.0
+             ENDIF
+
+          ENDIF
+!
+!--       Store humidity, rain water content and rain drop concentration 
+!--       gradient at the top boundary for possile Neumann boundary condition
+          bc_q_t_val  = ( q_init(nzt+1) - q_init(nzt) ) / dzu(nzt+1)
+            
+          IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+             bc_qr_t_val = ( qr_init(nzt+1) - qr_init(nzt) ) / dzu(nzt+1)
+             bc_nr_t_val = ( nr_init(nzt+1) - nr_init(nzt) ) / dzu(nzt+1)
+          ENDIF
 
        ENDIF
@@ -1344,16 +1458,20 @@
 !-- Set wind speed in the Galilei-transformed system
     IF ( galilei_transformation )  THEN
-       IF ( use_ug_for_galilei_tr .AND.                &
-            ug_vertical_gradient_level(1) == 0.0 .AND. & 
-            vg_vertical_gradient_level(1) == 0.0 )  THEN
+       IF ( use_ug_for_galilei_tr .AND.                  &
+            ug_vertical_gradient_level(1) == 0.0  .AND.  &
+            ug_vertical_gradient(1) == 0.0  .AND.        & 
+            vg_vertical_gradient_level(1) == 0.0  .AND.  &
+            vg_vertical_gradient(1) == 0.0 )  THEN
           u_gtrans = ug_surface * 0.6
           v_gtrans = vg_surface * 0.6
-       ELSEIF ( use_ug_for_galilei_tr .AND.                &
-                ug_vertical_gradient_level(1) /= 0.0 )  THEN
+       ELSEIF ( use_ug_for_galilei_tr  .AND.                  &
+                ( ug_vertical_gradient_level(1) /= 0.0  .OR.  &
+                ug_vertical_gradient(1) /= 0.0 ) )  THEN
           message_string = 'baroclinicity (ug) not allowed simultaneously' // &
                            ' with galilei transformation'
           CALL message( 'check_parameters', 'PA0046', 1, 2, 0, 6, 0 )
-       ELSEIF ( use_ug_for_galilei_tr .AND.                &
-                vg_vertical_gradient_level(1) /= 0.0 )  THEN
+       ELSEIF ( use_ug_for_galilei_tr  .AND.                  &
+                ( vg_vertical_gradient_level(1) /= 0.0  .OR.  &
+                vg_vertical_gradient(1) /= 0.0 ) )  THEN
           message_string = 'baroclinicity (vg) not allowed simultaneously' // &
                            ' with galilei transformation'
@@ -1650,5 +1768,44 @@
           CALL message( 'check_parameters', 'PA0074', 1, 2, 0, 6, 0 )
        ENDIF
-       
+
+       IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+          IF ( bc_qr_b == 'dirichlet' )  THEN
+             ibc_qr_b = 0
+          ELSEIF ( bc_qr_b == 'neumann' )  THEN
+             ibc_qr_b = 1
+          ELSE
+             message_string = 'unknown boundary condition: bc_qr_b ="' // &
+                              TRIM( bc_qr_b ) // '"'
+             CALL message( 'check_parameters', 'PA0352', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( bc_qr_t == 'dirichlet' )  THEN
+             ibc_qr_t = 0
+          ELSEIF ( bc_qr_t == 'neumann' )  THEN
+             ibc_qr_t = 1
+          ELSE
+             message_string = 'unknown boundary condition: bc_qr_t ="' // &
+                              TRIM( bc_qr_t ) // '"'
+             CALL message( 'check_parameters', 'PA0353', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( bc_nr_b == 'dirichlet' )  THEN
+             ibc_nr_b = 0
+          ELSEIF ( bc_nr_b == 'neumann' )  THEN
+             ibc_nr_b = 1
+          ELSE
+             message_string = 'unknown boundary condition: bc_nr_b ="' // &
+                              TRIM( bc_nr_b ) // '"'
+             CALL message( 'check_parameters', 'PA0355', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( bc_nr_t == 'dirichlet' )  THEN
+             ibc_nr_t = 0
+          ELSEIF ( bc_nr_t == 'neumann' )  THEN
+             ibc_nr_t = 1
+          ELSE
+             message_string = 'unknown boundary condition: bc_nr_t ="' // &
+                              TRIM( bc_nr_t ) // '"'
+             CALL message( 'check_parameters', 'PA0356', 1, 2, 0, 6, 0 )
+          ENDIF
+       ENDIF       
+
     ENDIF
 
@@ -2483,4 +2640,78 @@
              hom(:,2,72,:) = SPREAD( zu, 2, statistic_regions+1 )
 
+          CASE ( 'nr' )
+             IF ( .NOT. cloud_physics )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for cloud_physics = .FALSE.'
+                CALL message( 'check_parameters', 'PA0094', 1, 2, 0, 6, 0 )
+             ELSEIF ( icloud_scheme /= 0 )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for cloud_scheme /= seifert_beheng'
+                CALL message( 'check_parameters', 'PA0358', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 73
+                dopr_unit(i)  = '1/m3'
+                hom(:,2,73,:)  = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'qr' )
+             IF ( .NOT. cloud_physics )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for cloud_physics = .FALSE.'
+                CALL message( 'check_parameters', 'PA0094', 1, 2, 0, 6, 0 )
+             ELSEIF ( icloud_scheme /= 0 )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for cloud_scheme /= seifert_beheng'
+                CALL message( 'check_parameters', 'PA0358', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 74
+                dopr_unit(i)  = 'kg/kg'
+                hom(:,2,74,:)  = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'qc' )
+             IF ( .NOT. cloud_physics )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for cloud_physics = .FALSE.'
+                CALL message( 'check_parameters', 'PA0094', 1, 2, 0, 6, 0 )
+             ELSEIF ( icloud_scheme /= 0 )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for cloud_scheme /= seifert_beheng'
+                CALL message( 'check_parameters', 'PA0358', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 75
+                dopr_unit(i)  = 'kg/kg'
+                hom(:,2,75,:)  = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'prr' )
+             IF ( .NOT. cloud_physics )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for cloud_physics = .FALSE.'
+                CALL message( 'check_parameters', 'PA0094', 1, 2, 0, 6, 0 )
+             ELSEIF ( icloud_scheme /= 0 )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for cloud_scheme /= seifert_beheng'
+                CALL message( 'check_parameters', 'PA0358', 1, 2, 0, 6, 0 )
+             ELSEIF ( .NOT. precipitation )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for precipitation = .FALSE.'
+                CALL message( 'check_parameters', 'PA0361', 1, 2, 0, 6, 0 )
+
+             ELSE
+                dopr_index(i) = 76
+                dopr_unit(i)  = 'kg/kg m/s'
+                hom(:,2,76,:)  = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
           CASE DEFAULT
 
@@ -2572,4 +2803,16 @@
              unit = 'K'
 
+          CASE ( 'nr' )
+             IF ( .NOT. cloud_physics )  THEN
+                message_string = 'output of "' // TRIM( var ) // '" requi' // &
+                         'res cloud_physics = .TRUE.'
+                CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
+             ELSEIF ( icloud_scheme /= 0 )  THEN
+                message_string = 'output of "' // TRIM( var ) // '" requi' // &
+                         'res cloud_scheme = seifert_beheng'
+                CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
+             ENDIF
+             unit = '1/m3'
+
           CASE ( 'pc', 'pr' )
              IF ( .NOT. particle_advection )  THEN
@@ -2581,4 +2824,20 @@
              IF ( TRIM( var ) == 'pr' )  unit = 'm'
 
+          CASE ( 'prr' )
+             IF ( .NOT. cloud_physics )  THEN
+                message_string = 'output of "' // TRIM( var ) // '" requi' // &
+                         'res cloud_physics = .TRUE.'
+                CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
+             ELSEIF ( icloud_scheme /= 0 )  THEN
+                message_string = 'output of "' // TRIM( var ) // '" requi' // &
+                         'res cloud_scheme = seifert_beheng'
+                CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
+             ELSEIF ( .NOT. precipitation )  THEN
+                message_string = 'output of "' // TRIM( var ) // '" requi' // &
+                                 'res precipitation = .TRUE.'
+                CALL message( 'check_parameters', 'PA0112', 1, 2, 0, 6, 0 )
+             ENDIF
+             unit = 'kg/kg m/s'
+
           CASE ( 'q', 'vpt' )
              IF ( .NOT. humidity )  THEN
@@ -2590,4 +2849,16 @@
              IF ( TRIM( var ) == 'vpt' )  unit = 'K'
 
+          CASE ( 'qc' )
+             IF ( .NOT. cloud_physics )  THEN
+                message_string = 'output of "' // TRIM( var ) // '" requi' // &
+                         'res cloud_physics = .TRUE.'
+                CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
+             ELSEIF ( icloud_scheme /= 0 ) THEN
+                message_string = 'output of "' // TRIM( var ) // '" requi' // &
+                         'res cloud_scheme = seifert_beheng'
+                CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
+             ENDIF
+             unit = 'kg/kg'
+
           CASE ( 'ql' )
              IF ( .NOT. ( cloud_physics  .OR.  cloud_droplets ) )  THEN
@@ -2607,4 +2878,16 @@
              IF ( TRIM( var ) == 'ql_v'  )  unit = 'm3'
              IF ( TRIM( var ) == 'ql_vp' )  unit = 'none'
+
+          CASE ( 'qr' )
+             IF ( .NOT. cloud_physics )  THEN
+                message_string = 'output of "' // TRIM( var ) // '" requi' // &
+                         'res cloud_physics = .TRUE.'
+                CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
+             ELSEIF ( icloud_scheme /= 0 ) THEN
+                message_string = 'output of "' // TRIM( var ) // '" requi' // &
+                         'res cloud_scheme = seifert_beheng'
+                CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
+             ENDIF
+             unit = 'kg/kg'
 
           CASE ( 'qv' )
